/**
 * 
 */
package demo;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Desktop;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.util.GenericForwardComposer;
import org.zkoss.zul.Button;
import org.zkoss.zul.Cell;
import org.zkoss.zul.Grid;
import org.zkoss.zul.Image;
import org.zkoss.zul.Label;
import org.zkoss.zul.ListModelList;
import org.zkoss.zul.Row;
import org.zkoss.zul.RowRenderer;
import org.zkoss.zul.Vlayout;

import demo.model.MessageboardManager;
import demo.model.User;
import demo.model.UserManager;

/**
 * @author Ian YT Tsai(zanyking)
 *
 */
public class AttendeesPanelViewCtrl extends GenericForwardComposer {

	private Button userBtn;
	private Grid attendeesGrid;
	
	public static AttendeesPanelViewCtrl getInstance(){
		return (AttendeesPanelViewCtrl) Executions.getCurrent().getDesktop().getAttribute("KEY_UserPanelViewCtrl");
	}
	public void doAfterCompose(final Component comp) throws Exception {
		super.doAfterCompose(comp);
		Executions.getCurrent().getDesktop().setAttribute("KEY_UserPanelViewCtrl", this);
		
		List<User> users = MessageboardServlet.getAttendees(
				(HttpServletRequest) execution.getNativeRequest());
		attendeesGrid.setModel(new ListModelList(users));
		attendeesGrid.setRowRenderer(new RowRenderer() {
			public void render(Row row, Object data) throws Exception {
				User user = (User) data;
				Vlayout cell = new Vlayout();
				new Image("/resource/user.png").setParent(row);
				new Label(user.getName()).setParent(cell);
				new Label(user.getEmail()).setParent(cell);
				cell.setParent(row);
				new Label(""+Cons.dd_MMM_yyyy.format(user.getJoinDate())).setParent(row);
			}
		});
		
		UserManager.getInstance().subscribe(new EventListener(){
			public void onEvent(Event event) throws Exception {
				Desktop desktop = comp.getDesktop();
				if(desktop==null || !desktop.isAlive()){
					UserManager.getInstance().unsubscribe(this);
					return;
				}
				
				if(UserManager.ON_USER_JOIN.equals(event.getName())){
					
				}else{
					
				}
			}});
	}

	public void refreshAttendeesGrid(){
		List<User> users = MessageboardManager.getInstance().getMessageboard().getAttendees();
		attendeesGrid.setModel(new ListModelList(users));
	}
	
	public void onClick$userBtn()throws Exception{
		if(UserManager.getInstance().hasJoined()){// user is already joined...
			UserManager.getInstance().leave();
			userBtn.setLabel("Join");
		}else{
			JoinDialog dialog = new JoinDialog();
			dialog.open(page);
			userBtn.setLabel("Leave");
		}
	}

	
}
