/**
 * 
 */
package demo;

import org.zkoss.zk.ui.Components;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.Page;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zul.Captcha;
import org.zkoss.zul.Label;
import org.zkoss.zul.Textbox;
import org.zkoss.zul.Window;

import demo.model.UserManager;

/**
 * @author Ian YT Tsai(zanyking)
 *
 */
public class JoinDialog extends Window {


	public JoinDialog() throws Exception{
		this.setClosable(true);
		this.setMode("highlighted");
		this.setWidth("400px");
//		this.setHeight("700px");
		this.setTitle("Wellcome to Join!");
		this.setBorder("normal");
		Executions.createComponents("_JoinDialog.zul", this, null);
		Components.wireVariables(this, this);
		Components.addForwards(this, this);
	}
	private Textbox nameTxb;
	private Textbox emailTxb;
	private Captcha cpa;
	private Textbox validationTxb;
	private Label captchaResult;
	
	private void validateInput(){
		nameTxb.getValue();
		emailTxb.getValue();
		if(!validateHuman()){
			onClick$regenBtn();
			throw new WrongValueException(validationTxb, " failed validation, please try it again!");
		}
	}
	
	private boolean validateHuman(){
		boolean ans = cpa.getValue().equalsIgnoreCase(validationTxb.getValue());
		captchaResult.setValue(ans? "OK": "Wrong");
		return ans; 
	}
	
	public void open(Page page) {
		this.setPage(page);
	}

	public void onClick$regenBtn(){
		cpa.randomValue();
		validationTxb.setValue(null);
	}
	public void onClick$confirmBtn(){
		try{
			validateInput();
		}catch(WrongValueException we){
			return;
		}
		// call User Manager to add this user. 
		UserManager.getInstance().join(nameTxb.getValue(), emailTxb.getValue());
		this.detach();
	}
	public void onClick$cancelBtn(){
		this.detach();
	}
}
