/**
 * 
 */
package demo;

import java.io.IOException;
import java.util.Date;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import demo.model.Message;
import demo.model.Messageboard;
import demo.model.MessageboardManager;
import demo.model.User;

/**
 * @author Ian YT Tsai(zanyking)
 *
 */
public class MessageboardServlet extends HttpServlet {

	@Override
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	}
	
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doPost(req, resp);
	}

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		Messageboard imb = MessageboardManager.getInstance().getMessageboard();
		
		req.setAttribute("lastMessagesUpdateDate", imb.getLastMessagesUpdateDate());
		req.setAttribute("lastAttendeesUpdateDate", imb.getLastAttendeesUpdateDate());
		req.setAttribute("messages", imb.getMessages());
		req.setAttribute("attendees", imb.getAttendees());
		
		RequestDispatcher dispatcher = req.getRequestDispatcher("/messageboard.jsp");
		dispatcher.forward(req, resp);
	}
	
	public static Date getLastMessagesUpdateDate(HttpServletRequest req){
		return (Date) req.getAttribute("lastMessagesUpdateDate");
	}

	public static Date getLastAttendeesUpdateDate(
			HttpServletRequest req) {
		return (Date) req.getAttribute("lastAttendeesUpdateDate");
	}

	public static List<Message> getMessages(HttpServletRequest req) {
		return (List<Message>) req.getAttribute("messages");
	}
	
	public static List<User> getAttendees(HttpServletRequest req) {
		return (List<User>) req.getAttribute("attendees");
	}
}
